#if 0

Revision history:

Rev. 1.5 -- A version of this got lost along the way, so I'm trying to
            get this to work at least as well as Rev. 1.4.  All changes
            marked with the current date, >= 91.11.05.

				Planned changes:
DONE          1) make report of percentage used the percentage of TOTAL
                 disk space used rather than remaining disk space;
DONE          2) return the percentage used so batch files can drop out
                 if 100% is not achieved;
              3) truncate pct. (if necessary);
DONE          4) fix bug that caused hangup if existing file were greater
                 than total space on destination drive;
DONE          5) GET THE SUCKER TO WORK.
                 
                 
                 
                 
                 
                 
                 
---------------------------------------------------------------------------
					 lines above here start with spaces 


Rev. 1.3 -- Change scheme to find smallest number of files that will fill
            the disk.  This is to keep the juicy little files from being
            used up too fast.  Procedure:
              1) find out maximum and minimum number of files that can be
                 used;
              2) figure out the fill percentage for these;
              3) keep decrementing the number of files and figuring out
                 the fill percentage;
              4) replace the list if the percentage is better or equal for
                 small numbers of files;
              5) keep going until the minimum number of files is checked.


Okay -- tried the above and it sucks.  Here's the new scheme:
              1) find out maximum and minimum number of files that can be
                 used;
              2) start with the minimum number, quit if best == ideal;
              3) add the largest files;
              4) keep decrementing the smallest file until all fit;
              5) decrement the second smallest, etc.;
              6) quit when the first add after a decrement is too small.
              
              
              
#endif


#define TEST 0


#include <durf.h>
#include <dos.h>

#define MAX_SIZE 525		/* maximum number of files on source disk */

typedef struct {
	char fname[13];
	long fsize;
	} file_t;

file_t files[MAX_SIZE];
short index[MAX_SIZE], found[MAX_SIZE];

short *work, *base, *farray;

long ideal;			/* goal in number of clusters */
long best = 0;		/* best fill attempt so far   */
long btemp;			/* temporary total of files   */

#if TEST
long itz;
#endif

struct find_t ffile;
short csize;			/* cluster size on destination drive */
short fcount;			/* number of files on source disk	 */

int compare();			/* used by qsort */


/***************************************************************************/
/***************************************************************************/
/***************************************************************************/



/*
dsort

dsort is now called with the number of files to check as an argument, so
the old algorithm is donkey-doo.

*/

void get_sum(num)
short num;
{
	short j;

	btemp = 0;
	for (j = 0; j < num; j++)
		btemp += files[farray[j]].fsize;

	return;
}


/* The current list of indices in farray has a better than best total, so
	bring everything up to date.
*/
void log_files(num)
short num;
{
	short j;

	best = btemp;
	for (j = 0; j < num; j++)
		found[j] = farray[j];
	found[j] = -1;
}


short arrange_index(indx, num)
short indx, num;
{
	while (++indx < num)
		farray[indx] = farray[indx - 1] + 1;

	if (farray[num - 1] >= fcount)
		return FALSE;
	else
		return TRUE;	/* successful */
}

/***************************************************************************/
short inc_index(num, fit)
short num, fit;
{
	static int toggle = -1;
	short indx;		/* index of last file in farray */
	short j;

	indx = num - 1;

#if TEST
	itz++;
#endif

	if (toggle++ % 1000 == 0)
		{
		if (toggle <= 5000)
			putch('.');
		else if (toggle <= 10000)
			{
			putch('\10');
			putch(' ');
			putch('\10');
			}
		else
			toggle = -1;
		}

	if (fit == FALSE)
		if (farray[indx] < (fcount - 1))	/* if room to increment end file */
			{
			++farray[indx];
			return TRUE;
			}

 	/* fit == TRUE or cannot increment end file */

	j = indx;
	while (j - 1 >= 0)
		{
		if (farray[j] - farray[j - 1] > 1)	/* look for non-consecutive */
			{
			++farray[j - 1];
			return (arrange_index(j - 1, num));
			}
		else
			--j;
		}
	/* if here, j == 0 */
	++farray[0];
	return (arrange_index(0, num));
}
/***************************************************************************/


void dsort(num)
short num;			/* number of files to examine */
{
	short j, fit;

 	farray = (short *)malloc(num * sizeof(short));

	if (farray == NULL)
		{
		printf("Out of memory error.\n");
		exit(16);
		}


/* Files now are sorted from largest to smallest.  Initialize farray. */

	for (j = 0; j < num; j++)
		farray[j] = j;

	while (best < ideal)
		{
		get_sum(num);
		if (btemp > ideal)
			{
			if (!inc_index(num, FALSE))
				break;
			}
		else /* btemp <= ideal */
			{
			if (btemp > best)
				log_files(num);

			if (btemp < ideal)
				{
				if (!inc_index(num, TRUE))
					break;
				}
			}
		}

	free(farray);

	return;
}



/***************************************************************************/
/***************************************************************************/
/***************************************************************************/

/* Load the found files into the files[] array */
void do_array(idx)
short idx;				/* index into files[] */
{
	extern int strcpy();

	strcpy(files[idx].fname, ffile.name);
	files[idx].fsize = ffile.size;
}



short main(argc, argv)
int argc;
char **argv;
{
	FILE *pcfile;
	struct diskfree_t drive;
	unsigned disk, dflt;
	long tempsize, total_size, all_disk, used_clstrs, avail_space;
	char *abet = "abcdefghijklmnopqrstuvwxyz";
	char *source = "*.*";
	char drv;
	short j;
	short pflag = FALSE;	/* print to file? */
	short nofitflag;
	short maxf, minf;	/* maximum/minimum number of files that will fit */
	float success;

#if 0
	if (argc < 2)
		CLS;
#endif
							/* 92.04.09 */
	puts("\n\n\nDFILL v.1.51 by Durf Freund         GEnie: D.FREUND   CIS: 76346,3237\n\
*********************************************************************\n");

	if (argc < 2)
		{
		puts("  DFILL is a no-frills utility that enables maximal usage of floppy");
		puts("disks.  The program will check the available space on the destination");
		puts("drive, then determine which files in the default directory (or path ");
		puts("specified with the -d option) should be copied to use the most space ");
		puts("on the drive.\n");
		puts("      USAGE:    DFILL [dest] \{ -f -d[path] \}\n");
		puts("where [dest] is the destination drive; for example, a:\n");
		puts("  The options -f and -d are optional.  If -f is present, DFILL will");
		puts("create FILES.LST with the names of the files found.  If -d is present,");
		puts("DFILL will search the specified path for the files to be copied.\n");
		puts("      EXAMPLE:  DFILL b: -f -dc:\\new\\*.gif\n");
		puts("will check c:\\new for .gif files to be copied to b:.  The names of");
		puts("the selected files will be written into FILES.LST on the default drive.");
		exit(1);
		}

	if (argv[1][1] != ':')
		{
		puts(" Please enter a drive letter followed by a colon,");
		puts("for example:\n\n                  DFILL a: <cr>\n");
		puts("Type DFILL <cr> for more detailed instructions.\n");
		exit(2);
		}
	drv = argv[1][0];
	if (drv < 'a')
		drv += ('a' - 'A');

	for (j = 0; abet[j] != drv && j < 26; j++);
	if (j == 26)
		{
		puts("You entered an illegal drive.  Please select a-z.");
		puts("Type DFILL <cr> for more detailed instructions.\n");
		exit(2);
		}

	disk = j + 1;

	_dos_getdrive(&dflt);
	if (dflt == disk)
		{
		puts("\nYou can't copy to the drive you're on, Dumdum.");
		exit(3);
		}

	if (argc > 2)
		{
		for (j = 2; j < argc; j++)
			{
			if (argv[j][0] != '-')
				{
				puts("Illegal command line argument.");
				puts("Please type DFILL <cr> for more detailed instructions.\n");
				exit(100);
				}
			switch (argv[j][1])
				{
				case 'f':
					pflag = TRUE;
					break;
				case 'd':
					source = &argv[j][2];
					break;
				default :
					{
					printf("%s is an illegal command line argument.\n",
					  	argv[j]);
					exit(100);
					}
				}
			}
		}

	if (!_dos_getdiskfree(disk, &drive))
		{
		csize = drive.sectors_per_cluster * drive.bytes_per_sector;
		ideal = drive.avail_clusters;
		all_disk = (long)drive.total_clusters * csize;
		avail_space = (long)drive.avail_clusters * drive.sectors_per_cluster *
						drive.bytes_per_sector;
		printf("\nAvailable space on drive %c: is %lu bytes in\n", argv[1][0],
				avail_space);
		printf("%u clusters (1 cluster = %u bytes).\n",
			drive.avail_clusters, drive.sectors_per_cluster *
			drive.bytes_per_sector);
		printf("\nTotal space on the drive is %lu bytes.\n\n", (long)all_disk);
		used_clstrs = drive.total_clusters - drive.avail_clusters;
		}
	else
		{
		puts("The disk isn't available, for some dang reason.");
		exit(99);
		}

	if (ideal == 0)
		{
		puts("\nThere is no free space on the specified drive.");
		exit(7);
		}


/* Here we know how much space is available on the destination drive.
	Now we have to find out what files are present on the default drive. */

	if (_dos_findfirst(source, _A_NORMAL, &ffile))
		{
		puts("\nNo files found, Maestro.\n");
		exit(4);
		}

	nofitflag = FALSE;

	if (ffile.size)
		{
		if (ffile.size <= avail_space)
			do_array(fcount++);	/* load up the files[] array */
		else
			nofitflag = TRUE;
		}

	while (!_dos_findnext(&ffile))
		{
		if (ffile.size)
			{
			if (ffile.size <= avail_space)
				do_array(fcount++);
			else
				nofitflag = TRUE;
			}
		if (fcount >= MAX_SIZE)
			{
			printf("Sorry.  This program only supports %d files on the source drive.",
				MAX_SIZE);
			exit(5);
			}
		}

/* Arrange the files by size. */

	qsort(&files[0], (size_t)fcount, (size_t)sizeof(file_t), compare);


/* Now replace the file sizes with the number of clusters required on the
	destination disk for the files. */

	total_size = 0;
	for (j = 0; j < fcount; j++)
		{
		tempsize = files[j].fsize / csize;
		if (files[j].fsize % csize)
			tempsize++;
		files[j].fsize = tempsize;
		total_size += tempsize;
		}

	if (total_size == 0)
		{
		puts("\n\nNone of the files will fit on the destination drive.\n");
		exit(6);
		}
	if (total_size <= ideal && nofitflag == FALSE)
		{
		puts("\n\nAll the files will fit.\n");
		exit(7);
		}

/*************************************************************************/

/* Determine the minimum and maximum number of files that will fit on the
	destination drive.  Files now are sorted largest -> smallest. */

	for (j = 0, tempsize = 0; tempsize <= ideal && j < fcount; j++)
		tempsize += files[j].fsize;
	minf = j - 1;

	for (j = fcount - 1, tempsize = 0; tempsize <= ideal && j >= 0; j--)
		tempsize += files[j].fsize;
	maxf = fcount - (j + 1);

 	if (minf < 1)
		minf = 1;

	best = 0;
	puts("");

	for (j = minf; j <= maxf; j++)
		{
		dsort(j);
		if (best == ideal)
			break;
		}

	if (best == 0)
		{
		puts("\15None of these files will fit on the specified drive.");
		exit(8);
		}

#if TEST
	printf("\nminf = %d  maxf = %d", minf, maxf);
	printf("\ntotal iterations = %ld", itz);
	puts("\n");
#endif

	success = ( ((float)best + used_clstrs) * 100) / drive.total_clusters;

	if (success == (float)100 )
		{
		printf("\15Copying the following files will use all the space on the\n");
		puts("destination drive.\n");
		}
	else
		{
		printf("\15Copying the following files will use %1.2f%% of all the space\n",
			success);
		printf("(filling %1.2f%% of the available space) on the destination drive.\n\n",
			((float)best * 100) / ideal );
		}

	if (pflag)
		{
		if ( (pcfile = fopen("files.lst", "w")) == NULL)
			puts("\nI couldn't open files.lst");
		}

	for (j = 0; found[j] > -1; j++)
		{
		printf("%-12.12s   ", files[found[j]].fname);
		if ( (j + 1) % 5 == 0 )		/* 92.04.09 */
			printf("\n");
		if (pflag && pcfile != NULL)
			fprintf(pcfile, "%s\n", files[found[j]].fname);
		}
	puts("\n\n");

	return (short)((best * 100) / ideal);
}


int compare(arg1, arg2)
file_t *arg1, *arg2;
{
	if (arg1->fsize == arg2->fsize)
		return 0;
	else
		return (arg1->fsize < arg2->fsize ? 1 : -1);
}

